;***********************************************************************
; AUTOMATICKE ZPRACOVANI YORP - SOUBORU
; ...klasifikace a zapis do souboru inf.all, *.t2x, *.obl
; pro soubory s hlavickou i bez hlavicky
;***********************************************************************



;**************************************************************************
;vystup: obliquita, T2x (Myr), de/dt (deg/Myr)
;**************************************************************************
pro qqq,nazev,xout,yout1,yout2
nmax=7   ;pocet radku souboru
ms=181   ;pocet bodu na spline
pol=4     ;pocet polozek na radku
st='#'

sklon=fltarr(nmax)
omega=sklon
gama=sklon
q=fltarr(pol)
;NACTENI DAT
;hlavicka
 imax=-1
 close,21
 openr,21,nazev
 while (strpos(st,'#') ne -1) do begin
  imax=imax+1
  readf,21,st
 endwhile
 close,21
 openr,21,nazev
 if imax gt 0 then for i=1,imax do readf,21,st
;data
 for i=0,nmax-1 do begin
  readf,21,q
  sklon(i)=q(0)
  omega(i)=q(1)
  gama(i)=q(2)
 endfor
 close,21

;SPLINE
tspl=findgen(ms)/float(ms-1)*180.
zspl1=fltarr(ms)
zspl2=fltarr(ms)
zspl1=spline(sklon,omega,tspl)
zspl2=spline(sklon,gama,tspl)

xout=tspl
yout1=(2.*!pi/6./60./60.)/zspl1/(3600.*24*365.25*1.e6)          ;T2x
yout2=zspl2/(2.*!pi/6./60./60.)*180./!pi*(3600.*24*365.25*1.e6) ;de/dt
end


;**************************************************************************
;x-ova poloha pruseciku s osou x
;**************************************************************************
function nulbod,x0,y0,x1,y1
 q=x0-(x1-x0)/(y1-y0)*y0
 return,q
end

;**************************************************************************
;linearni interpolace
;**************************************************************************
function interp,x0,y0,x1,y1,x
 q=y0+(y1-y0)/(x1-x0)*(x1-x)
 return,q
end




;**************************************************************************
;HLAVNI PROGRAM
;**************************************************************************
close,1
close,2
close,3
close,4
close,5
close,6
close,7
close,11
close,12
close,13
openw,1,'1.t2x'
openw,2,'2.t2x'
openw,3,'3.t2x'
openw,4,'4'
openw,11,'1.obl'
openw,12,'2.obl'
openw,13,'3.obl'
openw,5,'inf.all'

openw,6,'all.t2x'
openw,7,'all.obl'


;deklarace
ast=200
nkorenu=fltarr(ast)
class=intarr(ast)
asteroid=strarr(ast)

;telesa
asteroid(0:49)=[$
            '1.y', '2.y', '3.y', '4.y', '5.y', '6.y', '7.y', '8.y', '9.y','10.y',$
           '11.y','12.y','13.y','14.y','15.y','16.y','17.y','18.y','19.y','20.y',$
           '21.y','22.y','23.y','24.y','25.y','26.y','27.y','28.y','29.y','30.y',$
           '31.y','32.y','33.y','34.y','35.y','36.y','37.y','38.y','39.y','40.y',$
           '41.y','42.y','43.y','44.y','45.y','46.y','47.y','48.y','49.y','50.y']
asteroid(50:99)=[$
           '51.y','52.y','53.y','54.y','55.y','56.y','57.y','58.y','59.y','60.y',$
           '61.y','62.y','63.y','64.y','65.y','66.y','67.y','68.y','69.y','70.y',$
           '71.y','72.y','73.y','74.y','75.y','76.y','77.y','78.y','79.y','80.y',$
           '81.y','82.y','83.y','84.y','85.y','86.y','87.y','88.y','89.y','90.y',$
           '91.y','92.y','93.y','94.y','95.y','96.y','97.y','98.y','99.y','100.y']
asteroid(100:149)=[$
           '101.y','102.y','103.y','104.y','105.y','106.y','107.y','108.y','109.y','130.y',$
           '111.y','112.y','113.y','114.y','115.y','116.y','117.y','118.y','119.y','130.y',$
           '121.y','122.y','123.y','124.y','125.y','126.y','127.y','128.y','129.y','130.y',$
           '131.y','132.y','133.y','134.y','135.y','136.y','137.y','138.y','139.y','130.y',$
           '141.y','142.y','143.y','144.y','145.y','146.y','147.y','148.y','149.y','150.y']
asteroid(150:199)=[$
           '151.y','152.y','153.y','154.y','155.y','156.y','157.y','158.y','159.y','160.y',$
           '161.y','162.y','163.y','164.y','165.y','166.y','167.y','168.y','169.y','170.y',$
           '171.y','172.y','173.y','174.y','175.y','176.y','177.y','178.y','179.y','180.y',$
           '181.y','182.y','183.y','184.y','185.y','186.y','187.y','188.y','189.y','190.y',$
           '191.y','192.y','193.y','194.y','195.y','196.y','197.y','198.y','199.y','200.y']
;hlavicka
printf,5,'jmeno tr. |de/dt| koreny     T2x'
printf,5,'          deg/Myr  deg       Myr'
printf,5,'---------------------------------'

printf,6,ast
printf,7,ast

 ;pocitadla urychlovani a zpomalovani
 plus=0
 minus=0
 clI=0
 clII=0
 clIII=0
 clIV=0

;hlavni cyklus
for co=0,ast-1 do begin
 qqq,asteroid(co),xo,yo1,yo2
 kor=fltarr(20)
 ury=kor
 m=0
 ;hledani korenu
 for i=1,178 do begin
  x0=xo(i)
  x1=xo(i+1)
  y0=yo2(i)
  y1=yo2(i+1)
  if (y0*y1 le 0.) then begin
   m=m+1
   kor(m)=nulbod(x0,y0,x1,y1)
   ury(m)=interp(x0,yo1(i),x1,yo1(i+1),kor(m))
  endif
 endfor
 ;klasifikace
 nkorenu(co)=m
 class(co)=4
 if m eq 1 then begin
  class(co)=1
  if yo2(round(kor(1)/2)) lt 0. then class(co)=2
 endif
 if m eq 3 then begin
  class(co)=3
  if yo2(round(kor(1)/2)) lt 0. then class(co)=4
 endif
;obecny zapis
 printf,5,asteroid(co),class(co),max(abs(yo2)),0.,yo1(0),format='(a7,i3,f6.1,f8.2,f9.1)'
 for jk=1,m do printf,5,'                    ',kor(jk),ury(jk),format='(a16,f8.2,f9.1)'
 printf,5,'                    ',180.,yo1(180),format='(a16,f8.2,f9.1)'
 printf,5,' '

;zapis 1. tridy
if class(co) eq 1 then begin
 printf,1,ury(1)
 printf,11,max(abs(yo2))
 printf,6,ury(1)
 printf,7,max(abs(yo2))
 clI=clI+1
 if ury(1) ge 0 then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 2. tridy
if class(co) eq 2 then begin
 printf,2,yo1(0)
 printf,12,max(abs(yo2))
 printf,6,yo1(0)
 printf,7,max(abs(yo2))
 clII=clII+1
 if yo1(0) ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 3. tridy
if class(co) eq 3 then begin
 printf,3,(ury(1)+ury(3))/2.
 printf,13,max(abs(yo2))
 printf,6,(ury(1)+ury(3))/2.
 printf,7,max(abs(yo2))
 clIII=clIII+1
 if (ury(1)+ury(3))/2. ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis ostatnich trid
if class(co) ge 4 then begin
 clIV=clIV+1
 printf,4,asteroid(co)
endif



endfor

printf,5,'-------------------------------------'
printf,5,'urychlovano: ',plus,'...',plus/float(ast)*100,'%'
printf,5,'zpomalovano: ',minus,'...',minus/float(ast)*100,'%'
printf,5,'trida     I: ',clI,'...',clI/float(ast)*100,'%'
printf,5,'trida    II: ',clII,'...',clII/float(ast)*100,'%'
printf,5,'trida   III: ',clIII,'...',clIII/float(ast)*100,'%'
printf,5,'trida    IV: ',clIV,'...',clIV/float(ast)*100,'%'
close,1
close,2
close,3
close,4
close,5
close,11
close,12
close,13

close,6
close,7
end
