;***********************************************************************
; AUTOMATICKE ZPRACOVANI YORP - SOUBORU
; ...klasifikace a zapis do souboru inf.all, *.t2x, *.obl
; pro soubory s hlavickou i bez hlavicky
;
;	VERZE PRO DATA POCINANA RUBINCAMOVOU APROXIMACI
;
;***********************************************************************



;**************************************************************************
;vystup: obliquita, T2x (Myr), de/dt (deg/Myr)
;**************************************************************************
pro qqq,nazev,xout,yout1,yout2
nmax=91   ;pocet radku souboru
ms=181   ;pocet bodu na spline
pol=3     ;pocet polozek na radku
st='#'

sklon=fltarr(nmax)
omega=sklon
gama=sklon
q=fltarr(pol)
;NACTENI DAT
;hlavicka
 imax=-1
 close,21
 openr,21,nazev
 while (strpos(st,'#') ne -1) do begin
  imax=imax+1
  readf,21,st
 endwhile
 close,21
 openr,21,nazev
 if imax gt 0 then for i=1,imax do readf,21,st
;data
 for i=0,nmax-1 do begin
  readf,21,q
  sklon(i)=q(0)
  omega(i)=q(1)*1.5
  gama(i)=q(2)*1.5
 endfor
 close,21

;SPLINE
tspl=findgen(ms)/float(ms-1)*180.
zspl1=fltarr(ms)
zspl2=fltarr(ms)
zspl1=spline(sklon,omega,tspl)
zspl2=spline(sklon,gama,tspl)

xout=tspl
yout1=(2.*!pi/6./60./60.)/zspl1/(3600.*24*365.25*1.e6)          ;T2x
yout2=zspl2/(2.*!pi/6./60./60.)*180./!pi*(3600.*24*365.25*1.e6) ;de/dt
end


;**************************************************************************
;x-ova poloha pruseciku s osou x
;**************************************************************************
function nulbod,x0,y0,x1,y1
 q=x0-(x1-x0)/(y1-y0)*y0
 return,q
end

;**************************************************************************
;linearni interpolace
;**************************************************************************
function interp,x0,y0,x1,y1,x
 q=y0+(y1-y0)/(x1-x0)*(x1-x)
 return,q
end




;**************************************************************************
;HLAVNI PROGRAM
;**************************************************************************
close,1
close,2
close,3
close,4
close,5
close,6
close,7
close,11
close,12
close,13
openw,1,'1.t2x'
openw,2,'2.t2x'
openw,3,'3.t2x'
openw,4,'4'
openw,11,'1.obl'
openw,12,'2.obl'
openw,13,'3.obl'
openw,5,'inf.all'

openw,6,'all.t2x'
openw,7,'all.obl'


;deklarace
ast=200
nkorenu=fltarr(ast)
class=intarr(ast)
asteroid=strarr(ast)

;telesa
asteroid(0:49)=[$
           '001.mom','002.mom','003.mom','004.mom','005.mom','006.mom','007.mom','008.mom','009.mom','010.mom',$
           '011.mom','012.mom','013.mom','014.mom','015.mom','016.mom','017.mom','018.mom','019.mom','020.mom',$
           '021.mom','022.mom','023.mom','024.mom','025.mom','026.mom','027.mom','028.mom','029.mom','030.mom',$
           '031.mom','032.mom','033.mom','034.mom','035.mom','036.mom','037.mom','038.mom','039.mom','040.mom',$
           '041.mom','042.mom','043.mom','044.mom','045.mom','046.mom','047.mom','048.mom','049.mom','050.mom']
asteroid(50:99)=[$0
           '051.mom','052.mom','053.mom','054.mom','055.mom','056.mom','057.mom','058.mom','059.mom','060.mom',$
           '061.mom','062.mom','063.mom','064.mom','065.mom','066.mom','067.mom','068.mom','069.mom','070.mom',$
           '071.mom','072.mom','073.mom','074.mom','075.mom','076.mom','077.mom','078.mom','079.mom','080.mom',$
           '081.mom','082.mom','083.mom','084.mom','085.mom','086.mom','087.mom','088.mom','089.mom','090.mom',$
           '091.mom','092.mom','093.mom','094.mom','095.mom','096.mom','097.mom','098.mom','099.mom','100.mom']
asteroid(100:149)=[$
           '101.mom','102.mom','103.mom','104.mom','105.mom','106.mom','107.mom','108.mom','109.mom','130.mom',$
           '111.mom','112.mom','113.mom','114.mom','115.mom','116.mom','117.mom','118.mom','119.mom','130.mom',$
           '121.mom','122.mom','123.mom','124.mom','125.mom','126.mom','127.mom','128.mom','129.mom','130.mom',$
           '131.mom','132.mom','133.mom','134.mom','135.mom','136.mom','137.mom','138.mom','139.mom','130.mom',$
           '141.mom','142.mom','143.mom','144.mom','145.mom','146.mom','147.mom','148.mom','149.mom','150.mom']
asteroid(150:199)=[$
           '151.mom','152.mom','153.mom','154.mom','155.mom','156.mom','157.mom','158.mom','159.mom','160.mom',$
           '161.mom','162.mom','163.mom','164.mom','165.mom','166.mom','167.mom','168.mom','169.mom','170.mom',$
           '171.mom','172.mom','173.mom','174.mom','175.mom','176.mom','177.mom','178.mom','179.mom','180.mom',$
           '181.mom','182.mom','183.mom','184.mom','185.mom','186.mom','187.mom','188.mom','189.mom','190.mom',$
           '191.mom','192.mom','193.mom','194.mom','195.mom','196.mom','197.mom','198.mom','199.mom','200.mom']
;hlavicka
printf,5,'jmeno tr. |de/dt| koreny     T2x'
printf,5,'          deg/Myr  deg       Myr'
printf,5,'---------------------------------'

printf,6,ast
printf,7,ast

 ;pocitadla urychlovani a zpomalovani
 plus=0
 minus=0
 clI=0
 clII=0
 clIII=0
 clIV=0

;hlavni cyklus
for co=0,ast-1 do begin
 qqq,asteroid(co),xo,yo1,yo2
 kor=fltarr(20)
 ury=kor
 m=0
 ;hledani korenu
 for i=1,178 do begin
  x0=xo(i)
  x1=xo(i+1)
  y0=yo2(i)
  y1=yo2(i+1)
  if (y0*y1 le 0.) then begin
   m=m+1
   kor(m)=nulbod(x0,y0,x1,y1)
   ury(m)=interp(x0,yo1(i),x1,yo1(i+1),kor(m))
   if m gt 1 then begin
   	if kor(m) eq kor(m-1) then m=m-1
   endif
  endif
 endfor
 ;klasifikace
 nkorenu(co)=m
 class(co)=4
 if m eq 1 then begin
  class(co)=1
  if yo2(round(kor(1)/2)) lt 0. then class(co)=2
 endif
 if m eq 3 then begin
  class(co)=3
  if yo2(round(kor(1)/2)) lt 0. then class(co)=4
 endif
;obecny zapis
 printf,5,asteroid(co),class(co),max(abs(yo2)),0.,yo1(0),format='(a7,i3,f6.1,f8.2,f9.1)'
 for jk=1,m do printf,5,'                    ',kor(jk),ury(jk),format='(a16,f8.2,f9.1)'
 printf,5,'                    ',180.,yo1(180),format='(a16,f8.2,f9.1)'
 printf,5,' '

;zapis 1. tridy
if class(co) eq 1 then begin
 printf,1,ury(1)
 printf,11,max(abs(yo2))
 printf,6,ury(1)
 printf,7,max(abs(yo2))
 clI=clI+1
 if ury(1) ge 0 then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 2. tridy
if class(co) eq 2 then begin
 printf,2,yo1(0)
 printf,12,max(abs(yo2))
 printf,6,yo1(0)
 printf,7,max(abs(yo2))
 clII=clII+1
 if yo1(0) ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 3. tridy
if class(co) eq 3 then begin
 printf,3,(ury(1)+ury(3))/2.
 printf,13,max(abs(yo2))
 printf,6,(ury(1)+ury(3))/2.
 printf,7,max(abs(yo2))
 clIII=clIII+1
 if (ury(1)+ury(3))/2. ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis ostatnich trid
if class(co) ge 4 then begin
 clIV=clIV+1
 printf,4,asteroid(co)
endif



endfor

printf,5,'-------------------------------------'
printf,5,'urychlovano: ',plus,'...',plus/float(ast)*100,'%'
printf,5,'zpomalovano: ',minus,'...',minus/float(ast)*100,'%'
printf,5,'trida     I: ',clI,'...',clI/float(ast)*100,'%'
printf,5,'trida    II: ',clII,'...',clII/float(ast)*100,'%'
printf,5,'trida   III: ',clIII,'...',clIII/float(ast)*100,'%'
printf,5,'trida    IV: ',clIV,'...',clIV/float(ast)*100,'%'
close,1
close,2
close,3
close,4
close,5
close,11
close,12
close,13

close,6
close,7
end
