;***********************************************************************
; AUTOMATICKE ZPRACOVANI YORP - SOUBORU
; ...klasifikace a zapis do souboru inf.all, *.t2x, *.obl
; pro soubory s hlavickou i bez hlavicky
;***********************************************************************



;**************************************************************************
;vystup: obliquita, T2x (Myr), de/dt (deg/Myr)
;**************************************************************************
pro qqq,nazev,xout,yout1,yout2
nmax=7   ;pocet radku souboru
ms=181   ;pocet bodu na spline
pol=3     ;pocet polozek na radku
st='#'

sklon=fltarr(nmax)
omega=sklon
gama=sklon
q=fltarr(pol)
;NACTENI DAT
;hlavicka
 imax=-1
 close,21
 openr,21,nazev
 while (strpos(st,'#') ne -1) do begin
  imax=imax+1
  readf,21,st
 endwhile
 close,21
 openr,21,nazev
 if imax gt 0 then for i=1,imax do readf,21,st
;data
 for i=0,nmax-1 do begin
  readf,21,q
  sklon(i)=q(0)
  omega(i)=q(1)
  gama(i)=q(2)
 endfor
 close,21

;SPLINE
tspl=findgen(ms)/float(ms-1)*180.
zspl1=fltarr(ms)
zspl2=fltarr(ms)
zspl1=spline(sklon,omega,tspl)
zspl2=spline(sklon,gama,tspl)

xout=tspl
yout1=(2.*!pi/6./60./60.)/zspl1/(3600.*24*365.25*1.e6)          ;T2x
yout2=zspl2/(2.*!pi/6./60./60.)*180./!pi*(3600.*24*365.25*1.e6) ;de/dt
end


;**************************************************************************
;x-ova poloha pruseciku s osou x
;**************************************************************************
function nulbod,x0,y0,x1,y1
 q=x0-(x1-x0)/(y1-y0)*y0
 return,q
end

;**************************************************************************
;linearni interpolace
;**************************************************************************
function interp,x0,y0,x1,y1,x
 q=y0+(y1-y0)/(x1-x0)*(x1-x)
 return,q
end




;**************************************************************************
;HLAVNI PROGRAM
;**************************************************************************
close,1
close,2
close,3
close,4
close,5
close,6
close,7
close,11
close,12
close,13
openw,1,'1.t2x'
openw,2,'2.t2x'
openw,3,'3.t2x'
openw,4,'4.cls'
openw,11,'1.obl'
openw,12,'2.obl'
openw,13,'3.obl'
openw,5,'inf.all'

openw,6,'all.t2x'
openw,7,'all.obl'


close,8
openw,8,'1.cls'
close,9
openw,9,'2.cls'
close,10
openw,10,'3.cls'


;deklarace
close,21
openr,21,'gsphall.txt'
readf,21,ast	;ast=200
nkorenu=fltarr(ast)
class=intarr(ast)
asteroid=strarr(ast)
readf,21,asteroid
close,21
asteroid=asteroid+'.rub'

;hlavicka
printf,5,'jmeno tr. |de/dt| koreny     T2x'
printf,5,'          deg/Myr  deg       Myr'
printf,5,'---------------------------------'

printf,6,ast
printf,7,ast

 ;pocitadla urychlovani a zpomalovani
 plus=0
 minus=0
 clI=0
 clII=0
 clIII=0
 clIV=0

;hlavni cyklus
for co=0,ast-1 do begin
 qqq,asteroid(co),xo,yo1,yo2
 kor=fltarr(20)
 ury=kor
 m=0
 ;hledani korenu
 for i=1,178 do begin
  x0=xo(i)
  x1=xo(i+1)
  y0=yo2(i)
  y1=yo2(i+1)
  if (y0*y1 le 0.) then begin
   	m=m+1
	kor(m)=nulbod(x0,y0,x1,y1)
   	ury(m)=interp(x0,yo1(i),x1,yo1(i+1),kor(m))
   	if kor(m) eq kor(m-1) then m=m-1
  endif
 endfor
 ;klasifikace
 nkorenu(co)=m
 class(co)=4
 if m eq 1 then begin
  class(co)=1
  if yo2(round(kor(1)/2)) lt 0. then class(co)=2
 endif
 if m eq 3 then begin
  class(co)=3
  if yo2(round(kor(1)/2)) lt 0. then class(co)=4
 endif
;obecny zapis
 printf,5,asteroid(co),class(co),max(abs(yo2)),0.,yo1(0),format='(a7,i3,f6.1,f8.2,f9.1)'
 for jk=1,m do printf,5,'                    ',kor(jk),ury(jk),format='(a16,f8.2,f9.1)'
 printf,5,'                    ',180.,yo1(180),format='(a16,f8.2,f9.1)'
 printf,5,' '

;zapis 1. tridy
if class(co) eq 1 then begin
 printf,1,ury(1)
 printf,11,max(abs(yo2))
 printf,6,ury(1)
 printf,7,max(abs(yo2))
 printf,8,asteroid(co)
 clI=clI+1
 if ury(1) ge 0 then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 2. tridy
if class(co) eq 2 then begin
 printf,2,yo1(0)
 printf,12,max(abs(yo2))
 printf,6,yo1(0)
 printf,7,max(abs(yo2))
 printf,9,asteroid(co)
 clII=clII+1
 if yo1(0) ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis 3. tridy
if class(co) eq 3 then begin
 printf,3,(ury(1)+ury(3))/2.
 printf,13,max(abs(yo2))
 printf,6,(ury(1)+ury(3))/2.
 printf,7,max(abs(yo2))
 printf,10,asteroid(co)
clIII=clIII+1
 if (ury(1)+ury(3))/2. ge 0. then begin
  plus=plus+1
 endif else begin
  minus=minus+1
 endelse
endif

;zapis ostatnich trid
if class(co) ge 4 then begin
 clIV=clIV+1
 printf,4,asteroid(co)
endif



endfor

printf,5,'-------------------------------------'
printf,5,'urychlovano: ',plus,'...',plus/float(ast)*100,'%'
printf,5,'zpomalovano: ',minus,'...',minus/float(ast)*100,'%'
printf,5,'trida     I: ',clI,'...',clI/float(ast)*100,'%'
printf,5,'trida    II: ',clII,'...',clII/float(ast)*100,'%'
printf,5,'trida   III: ',clIII,'...',clIII/float(ast)*100,'%'
printf,5,'trida    IV: ',clIV,'...',clIV/float(ast)*100,'%'
close,1
close,2
close,3
close,4
close,5
close,11
close,12
close,13

close,6
close,7

close,8
close,9
close,10
end
