c intep_test.f
c Test of Hermite polynomial interpolation.
c Miroslav Broz (miroslav.broz@email.cz), Dec 7th 2009

      program intep_test

      implicit none
      include 'simplex.inc'

      character*80 file_synth
      real*8 lambda1, lambda2, dlambda

      integer n, IER, i
      real*8 lambda_synth(1:NLAMBDA_MAX), Int_synth(1:NLAMBDA_MAX)
      real*8 lambda, eps, Int_interp
      character*80 str

      if (iargc().eq.0) then
c read input parameters
        read(*,10) file_synth
10      format(a)
        read(*,*) lambda1, lambda2
        read(*,*) dlambda
      else if (iargc().eq.4) then
        call getarg(1, file_synth)
        call getarg(2, str)
        read(str,*,err=13,end=13) lambda1
        call getarg(3, str)
        read(str,*,err=13,end=13) lambda2
        call getarg(4, str)
        read(str,*,err=13,end=13) dlambda
        goto 14
13      continue
        write(*,15)
        stop
14      continue
      else
        write(*,15)
15      format('Usage: intep_test infile lambda1 lambda2 dlambda')
        stop
      endif

c read spectrum from file
      call read_synth(file_synth, n, lambda_synth, Int_synth)

c      do i = 1, n
c        write(*,*) '# ', lambda_synth(i), Int_synth(i)     ! dbg
c      enddo

c interpolate and write output
      lambda = lambda1
      eps = 1.d-8
      do while (lambda.le.lambda2+eps)
        call intep(lambda, Int_interp, lambda_synth, Int_synth, n, IER)
        if (IER.eq.2) then
          write(*,*) "# Warning: IER.eq.2 in intep()"
        endif

        write(*,*) lambda, Int_interp

        lambda = lambda + dlambda
      enddo

      stop
      end


